/*
 * $Id: class_model_tau.h,v 1.2 2016/04/28 08:15:16 ymaslenko Exp $
 * ymaslenko 2015
 */
#ifndef CLASS_MODEL_TAU_H
#define CLASS_MODEL_TAU_H

#include <stdbool.h>

/* ---------------- Structures -------------------------------- */
enum cmodel {
    SINGLE_NORMAL, /* gaussian normal distribution                */
            MULTI_NORMAL, /* correlated gaussian normal distribution     */
            UNKNOWN          /* unknown distribution                        */
};

struct clssfcn7 {                  /* structure to store a classification */
    double ***params7;               /* parameters for each class in each dimension */
    double **cov_matrix7;           /* (1-dim) covariance matrix of each class */
    float *class_weight7;           /* relative population of each class */
    enum cmodel **classmodel7;      /* which kinds of models are used */
    size_t n_class;                /* number of classes */
    size_t dim;                    /* dimension of feature space (input-vector) */
    float abs_error_dist;          /* absolut error in (input) measurement for DIST */
    float abs_error_tau;           /* absolut error in (input) measurement for sin/cos(TAU) */
};

struct clssfcn7 *tau_get_clssfcn(const char *influence_report_filename,
                                 const float abs_error_dist,
                                 const float abs_error_tau);

/*void clssfcn_destroy(struct clssfcn7 *c);*/

float *tau_computeMembership(float *mship, const float *test_vec,
                             const struct clssfcn7 *cmodel);

float *tau_computeMembershipStrct(float *mship, const float *test_vec,
                                  const struct clssfcn7 *cmodel);

#endif /* CLASS_MODEL_TAU_H */

